package com.mapbox.mapboxglexample;

import android.util.Log;
import android.widget.Toast;

import androidx.annotation.NonNull;

import io.flutter.embedding.android.FlutterActivity;
import io.flutter.embedding.engine.FlutterEngine;
import io.flutter.plugin.common.MethodChannel;
//sdk
import android.Manifest;
import android.os.Bundle;
import com.indooratlas.android.sdk.IALocation;
import com.indooratlas.android.sdk.IALocationListener;
import com.indooratlas.android.sdk.IALocationManager;
import com.indooratlas.android.sdk.IALocationRequest;
import androidx.core.app.ActivityCompat;

public class MainActivity extends FlutterActivity {
    private static String CHANNEL = "com.mapbox.mapboxglexample";
    private MethodChannel  channel;
    IALocationManager mIALocationManager;
    private final int CODE_PERMISSIONS = 7;
    @Override
    public void configureFlutterEngine(@NonNull FlutterEngine flutterEngine) {
        super.configureFlutterEngine(flutterEngine);
        channel = new MethodChannel(flutterEngine.getDartExecutor().getBinaryMessenger(), CHANNEL);
        channel.setMethodCallHandler((call, result) -> {
                //            Log.e("mymethod", "aboveAll"+call.method.toString());
            if(call.method.equalsIgnoreCase("mymethod") ){
                //                Log.e("mymethod", "mynameiskamal");
                Toast.makeText(this, "im toast", Toast.LENGTH_SHORT).show();
               
                mIALocationManager = IALocationManager.create(this);
                 String[] neededPermissions = {
                Manifest.permission.ACCESS_COARSE_LOCATION,
                Manifest.permission.ACCESS_FINE_LOCATION,
                Manifest.permission.BLUETOOTH_SCAN
             };
             ActivityCompat.requestPermissions( this, neededPermissions, CODE_PERMISSIONS );
            }
            if(call.method.equalsIgnoreCase("mymethod1") ){
  channel.invokeMethod("mymethod1",  "lat");
            }
        });
    }

   @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        mIALocationManager = IALocationManager.create(this);
        String[] neededPermissions = {
                Manifest.permission.ACCESS_COARSE_LOCATION,
                Manifest.permission.ACCESS_FINE_LOCATION,
                Manifest.permission.BLUETOOTH_SCAN
        };
        ActivityCompat.requestPermissions( this, neededPermissions, CODE_PERMISSIONS );
    }

        @Override
        public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if(requestCode==CODE_PERMISSIONS)
        {
            Log.e("perm accpt","=");
          //  mIALocationManager.registerRegionListener(this);
            mIALocationManager.lockIndoors(false);
            mIALocationManager.requestLocationUpdates(IALocationRequest.create(), mIALocationListener);
        }
    }
public String lat="";
    private IALocationListener mIALocationListener = new IALocationListener() {
        // Called when the location has changed.
        @Override
        public void onLocationChanged(IALocation location) {
        //    Toast.makeText(MainActivity.this, "changed=", Toast.LENGTH_SHORT).show();
        //    yaha toast dalna hai
        lat = ""+location.getLatitude();
            Log.e("lat", "Latitude: " + location.getLatitude());
            Log.e("long", "Longitude: " + location.getLongitude());
            Log.e("floor", "Floor number: " + location.getFloorLevel());
            channel.invokeMethod("mymethod1",  location.getLatitude()+","+location.getLongitude());
             }

        @Override
        public void onStatusChanged(String s, int i, Bundle bundle) {

        }
    };
   
    @Override
    protected void onResume() {
        super.onResume();
        mIALocationManager.requestLocationUpdates(IALocationRequest.create(), mIALocationListener);
    }
}
