import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:fluttertoast/fluttertoast.dart';
// import 'package:mapbox_gl_example/http/services.dart';
import 'package:flutter_dotenv/flutter_dotenv.dart';
// import 'package:insuideindoor/http/services.dart';
import 'package:insuideindoor/mainLib/http/services.dart';
import 'package:insuideindoor/mainLib/models/poi_model.dart';
// import 'package:insuideindoor/models/poi_model.dart';
import 'package:mapbox_gl/mapbox_gl.dart';
// import 'package:mapbox_gl_example/models/poi_model.dart';

class MyHome extends StatefulWidget {
  final data;
  const MyHome({Key? key, @required this.data}) : super(key: key);

  @override
  State<MyHome> createState() => _MyHomeState();
}

class _MyHomeState extends State<MyHome> {
  // LatLng? latLngPresent = GetLatLngFromSP();
  double? userLat;
  double? userLong;

  late CameraPosition _initialCameraPosition;

  late MapboxMapController controller;
  bool isLoading = true;

  int? loopCounter;

  GetPoi? poiPoints;
  List<LatLng> poisList = [];
  List<String> poisSubCat = [];
  LatLng? currentLocationIA;
  bool t1 = false;
  // List<MapMarker> mapMarkerList = [];

  @override
  void initState() {
    super.initState();
    print("widget.data ${widget.data}");
    LatLng aaa = convertToLatLng();
    isLoading = true;
    //LatLng(19.093099, 72.856952)
    _initialCameraPosition = CameraPosition(
        target: LatLng(19.093099, 72.856952), zoom: 17, tilt: 30.0);
    fetchPois();
  }

  LatLng convertToLatLng() {
    String a = widget.data;
    List latlng = a.split(',');
    double _lat = double.parse(latlng[0]);
    double _lng = double.parse(latlng[1]);
    LatLng finalIALatLng = LatLng(_lat, _lng);
    print("finalIALatLng $finalIALatLng");
    return finalIALatLng;
  }

  void _onMapCreated(MapboxMapController mapboxMapController) {
    controller = mapboxMapController;
  }

  fetchPois() async {
    poiPoints = await InternetService().getPOI().then((value) {
      loopCounter = value!.data!.length;
      poisList.clear();
      poisSubCat.clear();
      for (int a = 1; a <= loopCounter!; a++) {
        // print("latlng ${a - 1} is : ${value.data![a - 1].lat}");
        poisList.insert(
            a - 1, LatLng(value.data![a - 1].lat!, value.data![a - 1].lng!));

        poisSubCat.insert(
            a - 1, value.data?[a - 1].poiMultilingual!.en!.name ?? "Test");
      }
      return null;
    });
    if (!mounted) return;
    setState(() {
      isLoading = false;
    });
  }

  customPOIbasedonLevelId(levelId) async {
    poiPoints = await InternetService().getPOI().then((value) {
      loopCounter = value!.data!.length;
      // print("levelid ${value.data![0].levelid}");
      poisList.clear();
      poisSubCat.clear();
      for (int a = 1; a <= loopCounter!; a++) {
        if (value.data![0].levelid == levelId) {
          poisList.insert(
              a - 1, LatLng(value.data![a - 1].lat!, value.data![a - 1].lng!));

          poisSubCat.insert(
              a - 1, value.data?[a - 1].poiMultilingual!.en!.name ?? "Test");
        }
      }
      return null;
    });
    if (!mounted) return;
    setState(() {
      isLoading = false;
    });
  }

  customPOIbasedontTERMINALId(levelId) async {
    poiPoints = await InternetService().getPOI().then((value) {
      loopCounter = value!.data!.length;
      // print("levelid ${value.data![0].levelid}");
      poisList.clear();
      poisSubCat.clear();
      for (int a = 1; a <= loopCounter!; a++) {
        if (value.data![0].terminal == levelId) {
          poisList.insert(
              a - 1, LatLng(value.data![a - 1].lat!, value.data![a - 1].lng!));
          poisSubCat.insert(
              a - 1, value.data?[a - 1].poiMultilingual!.en!.name ?? "Test");
        }
      }
      return null;
    });
    if (!mounted) return;
    setState(() {
      isLoading = false;
    });
  }

  ///THE ABOVE 2 FUNCTIONS CAN BE CLUBBED IN ONE

  tappedaFunction(Symbol symbol) {
    print("print $symbol");

    Fluttertoast.showToast(
      msg: 'Tapped on POI',
      // backgroundColor: Colors.black,
      // textColor: whiteColor,
    );
  }

  void addSymbol(MapboxMapController mapBoxController) {
    for (int a = 0; a < loopCounter!; a++) {
      // print("kkkkkk ${poisList[a]}");
      mapBoxController.addSymbol(
        SymbolOptions(
            geometry: poisList[a],
            iconImage: "assets/symbols/neww.png",
            iconSize: 0.5,
            textField: poisSubCat[a],
            textSize: 15,
            iconOffset: const Offset(0, -50)),
      );
    }
    mapBoxController.onSymbolTapped.add(tappedaFunction);

    //SHOWING CURRENT USER LOCATION ON MAP
    mapBoxController.addSymbol(
      SymbolOptions(
        // geometry: LatLng(19.093099, 72.856952),
        geometry: convertToLatLng(),

        iconImage: "assets/symbols/Oval.png",
        iconSize: 3,
      ),
    );
    mapBoxController.onSymbolTapped.add(tappedaFunction);
  }

  var styleString =
      'mapbox://styles/merrillgonsalves/cl5ez27io005p14rz5aqp8234';

  var t1l1 = 'mapbox://styles/merrillgonsalves/cl5ez27io005p14rz5aqp8234';
  var t1l2 = 'mapbox://styles/merrillgonsalves/cl5ez2lht002214s0ow0ghr8z';
  var t1l3 = 'mapbox://styles/merrillgonsalves/cl5l2hq6w001o15nxfhzighuw';

  var t2l1 = 'mapbox://styles/merrillgonsalves/cl5ez2e9l000j14r0y08curhk';
  var t2l2 = 'mapbox://styles/merrillgonsalves/cl5ez205n002h14pvay28t8iz';
  var t2l3 = 'mapbox://styles/merrillgonsalves/cl5c9c84e006o14nu2a8sny58';
  var t2l4 = 'mapbox://styles/merrillgonsalves/cl508fw8s000u15rsht67q9tx';

  @override
  Widget build(BuildContext context) {
    const Channel = MethodChannel("com.mapbox.mapboxglexample");
    const platform = const MethodChannel("com.mapbox.mapboxglexample");

    platform.setMethodCallHandler((call) async {
      print("init state setMethodCallHandler ${call.arguments}");
      setState(() {
        // _initialCameraPosition =
        //     CameraPosition(target: convertToLatLng(), zoom: 17, tilt: 30.0);
      });
      ScaffoldMessenger.of(context).showSnackBar(
        SnackBar(
          content: Text(convertToLatLng().toString()),
        ),
      );
    });
    // setState(() {
    //   _initialCameraPosition =
    //       CameraPosition(target: convertToLatLng(), zoom: 17, tilt: 30.0);
    //   ScaffoldMessenger.of(context).showSnackBar(
    //     SnackBar(
    //       content: Text(widget.data),
    //     ),
    //   );
    // });
    double myHeight = MediaQuery.of(context).size.height / 3.8;
    double myBigHeight = MediaQuery.of(context).size.height - myHeight - 100;
    double width = MediaQuery.of(context).size.width;
    double height = MediaQuery.of(context).size.height;
    double btnPadding = 10.0;
    double btnSize = 25.0;
    double fontSize = 16.0;
    return Scaffold(
      body: SafeArea(
          child: Container(
        width: width,
        height: height,
        child: Stack(
          children: [
            SizedBox(
              child: isLoading
                  ? Center(
                      child: Column(
                        mainAxisAlignment: MainAxisAlignment.center,
                        children: [
                          CircularProgressIndicator(),
                          SizedBox(
                            height: 20,
                          ),
                          Text("Loading POI's & IA Location")
                        ],
                      ),
                    )
                  : Column(
                      children: [
                        Stack(
                          alignment: Alignment.bottomCenter,
                          children: [
                            Container(
                              height: myBigHeight,
                              child: MapboxMap(
                                tiltGesturesEnabled: true,
                                accessToken: dotenv.env['MAPBOX_ACCESS_TOKEN'],
                                initialCameraPosition: _initialCameraPosition,
                                onMapCreated: _onMapCreated,
                                trackCameraPosition: true,
                                onCameraTrackingChanged: (mode) {
                                  // print("mode.name ${mode}");
                                  // print("mode.name ${mode.name}");
                                },

                                onStyleLoadedCallback: () =>
                                    addSymbol(controller),
                                // myLocationEnabled: true,
                                myLocationTrackingMode:
                                    MyLocationTrackingMode.TrackingGPS,
                                // minMaxZoomPreference:
                                //     const MinMaxZoomPreference(14, 17),
                                annotationOrder: [AnnotationType.symbol],
                                styleString: styleString,
                              ),
                            ),
                            Container(
                              margin: EdgeInsets.only(left: 20, right: 20),
                              padding: EdgeInsets.only(bottom: 10),
                              child: Row(
                                crossAxisAlignment: CrossAxisAlignment.end,
                                mainAxisAlignment:
                                    MainAxisAlignment.spaceBetween,
                                children: [
                                  GestureDetector(
                                    onTap: () {
                                      controller.animateCamera(
                                          CameraUpdate.newCameraPosition(
                                              CameraPosition(
                                                  target: convertToLatLng())));
                                    },
                                    child: Container(
                                      padding: EdgeInsets.all(btnPadding),
                                      decoration: BoxDecoration(
                                          color: Colors.white,
                                          borderRadius:
                                              BorderRadius.circular(10)),
                                      child: Icon(
                                        Icons.gps_fixed,
                                        size: btnSize,
                                      ),
                                    ),
                                  ),
                                  Column(
                                    children: [
                                      GestureDetector(
                                        onTap: () {
                                          showModalBottomSheet<void>(
                                            context: context,
                                            builder: (BuildContext context) {
                                              return Container(
                                                decoration: const BoxDecoration(
                                                    color: Colors.white,
                                                    borderRadius:
                                                        BorderRadius.only(
                                                            topLeft: Radius
                                                                .circular(50),
                                                            topRight:
                                                                Radius.circular(
                                                                    50))),
                                                child: Padding(
                                                  padding: const EdgeInsets.all(
                                                      10.0),
                                                  child: SingleChildScrollView(
                                                    child: Column(
                                                      crossAxisAlignment:
                                                          CrossAxisAlignment
                                                              .start,
                                                      children: [
                                                        TextButton(
                                                            onPressed: () {
                                                              setState(() {
                                                                isLoading =
                                                                    true;
                                                              });
                                                              customPOIbasedonLevelId(
                                                                  0);
                                                              Navigator.pop(
                                                                  context);
                                                              _body(t1l1);
                                                            },
                                                            child: Text(
                                                                "Level 0")),
                                                        TextButton(
                                                            onPressed: () {
                                                              setState(() {
                                                                isLoading =
                                                                    true;
                                                              });
                                                              customPOIbasedonLevelId(
                                                                  1);
                                                              Navigator.pop(
                                                                  context);
                                                              _body(t1l2);
                                                            },
                                                            child: Text(
                                                                "Level 1")),
                                                        TextButton(
                                                            onPressed: () {
                                                              setState(() {
                                                                isLoading =
                                                                    true;
                                                              });
                                                              customPOIbasedonLevelId(
                                                                  2);
                                                              Navigator.pop(
                                                                  context);
                                                              _body(t1l3);
                                                            },
                                                            child: Text(
                                                                "Level 2")),
                                                        TextButton(
                                                            onPressed: () {
                                                              setState(() {
                                                                isLoading =
                                                                    true;
                                                              });
                                                              customPOIbasedonLevelId(
                                                                  3);
                                                              Navigator.pop(
                                                                  context);
                                                            },
                                                            child: Text(
                                                                "Level 3")),
                                                        TextButton(
                                                            onPressed: () {
                                                              setState(() {
                                                                isLoading =
                                                                    true;
                                                              });
                                                              customPOIbasedonLevelId(
                                                                  4);
                                                              Navigator.pop(
                                                                  context);
                                                            },
                                                            child: Text(
                                                                "Level 4")),
                                                      ],
                                                    ),
                                                  ),
                                                ),
                                              );
                                            },
                                          );
                                        },
                                        child: Container(
                                          padding: EdgeInsets.all(btnPadding),
                                          decoration: BoxDecoration(
                                              color: Colors.white,
                                              borderRadius: BorderRadius.only(
                                                  topLeft: Radius.circular(7),
                                                  topRight:
                                                      Radius.circular(7))),
                                          child:
                                              Icon(Icons.layers, size: btnSize),
                                        ),
                                      ),
                                      SizedBox(
                                        height: 1,
                                      ),
                                      GestureDetector(
                                        child: Container(
                                          padding: EdgeInsets.all(btnPadding),
                                          decoration: BoxDecoration(
                                            color: Colors.white,
                                            // borderRadius:BorderRadius.circular(10)
                                          ),
                                          child: Icon(Icons.directions,
                                              size: btnSize),
                                        ),
                                      ),
                                      SizedBox(
                                        height: 1,
                                      ),
                                      GestureDetector(
                                        onTap: () {
                                          showModalBottomSheet<void>(
                                            context: context,
                                            builder: (BuildContext context) {
                                              return Container(
                                                decoration: const BoxDecoration(
                                                    color: Colors.white,
                                                    borderRadius:
                                                        BorderRadius.only(
                                                            topLeft: Radius
                                                                .circular(50),
                                                            topRight:
                                                                Radius.circular(
                                                                    50))),
                                                child: Padding(
                                                  padding: const EdgeInsets.all(
                                                      10.0),
                                                  child: SingleChildScrollView(
                                                    child: Column(
                                                      crossAxisAlignment:
                                                          CrossAxisAlignment
                                                              .start,
                                                      children: [
                                                        TextButton(
                                                            onPressed: () {
                                                              // styleString =
                                                              //     "mapbox://styles/merrillgonsalves/cl5ez27io005p14rz5aqp8234";
                                                              // setState(() {});

                                                              // customPOIbasedontTERMINALId(
                                                              //         1)
                                                              //     .then((value) {
                                                              //   controller.animateCamera(
                                                              //       CameraUpdate.newCameraPosition(CameraPosition(
                                                              //           target: LatLng(
                                                              //               72.85610889365556,
                                                              //               19.09214918115378),
                                                              //           zoom: 17,
                                                              //           tilt: 30.0)));
                                                              // });

                                                              // controller.animateCamera(CameraUpdate.newCameraPosition(CameraPosition(
                                                              //     target: LatLng(
                                                              //         19.09214918115378,
                                                              //         72.85610889365556),
                                                              //     zoom: 17,
                                                              //     tilt: 30.0)));

                                                              Navigator.pop(
                                                                  context);
                                                              // void addSymbol(
                                                              //     MapboxMapController
                                                              //         mapBoxController) {
                                                              //   mapBoxController
                                                              //       .addSymbol(
                                                              //     SymbolOptions(
                                                              //       geometry: LatLng(
                                                              //           19.09214918115378,
                                                              //           72.85610889365556),
                                                              //       iconImage:
                                                              //           "assets/symbols/Oval.png",
                                                              //       iconSize: 3,
                                                              //     ),
                                                              //   );
                                                              // }

                                                              _body(t1l1);
                                                            },
                                                            child: Text(
                                                                "Terminal 1")),
                                                        TextButton(
                                                            onPressed: () {
                                                              // styleString =
                                                              //     "mapbox://styles/merrillgonsalves/cl5ez2lht002214s0ow0ghr8z";
                                                              // setState(() {});
                                                              // setState(() {
                                                              //   isLoading = true;
                                                              // });
                                                              // customPOIbasedontTERMINALId(
                                                              //     2);
                                                              // controller.animateCamera(CameraUpdate.newCameraPosition(CameraPosition(
                                                              //     target: LatLng(
                                                              //         19.099013794366645,
                                                              //         72.87337468789997),
                                                              //     zoom: 17,
                                                              //     tilt: 30.0)));
                                                              // void addSymbol(
                                                              //     MapboxMapController
                                                              //         mapBoxController) {
                                                              //   mapBoxController
                                                              //       .addSymbol(
                                                              //     SymbolOptions(
                                                              //       geometry:
                                                              //           LatLng(
                                                              //         19.099013794366645,
                                                              //         72.87337468789997,
                                                              //       ),
                                                              //       iconImage:
                                                              //           "assets/symbols/Oval.png",
                                                              //       iconSize: 3,
                                                              //     ),
                                                              //   );
                                                              // }

                                                              Navigator.pop(
                                                                  context);
                                                              _body(t2l1);
                                                            },
                                                            child: Text(
                                                                "Terminal 2")),
                                                      ],
                                                    ),
                                                  ),
                                                ),
                                              );
                                            },
                                          );
                                        },
                                        child: Container(
                                          padding: EdgeInsets.all(btnPadding),
                                          decoration: BoxDecoration(
                                              color: Colors.white,
                                              borderRadius: BorderRadius.only(
                                                  bottomLeft:
                                                      Radius.circular(7),
                                                  bottomRight:
                                                      Radius.circular(7))),
                                          child: Icon(Icons.airplane_ticket,
                                              size: btnSize),
                                        ),
                                      ),
                                    ],
                                  ),
                                ],
                              ),
                            ),
                          ],
                        ),
                        Column(
                          children: [
                            SizedBox(height: 5),
                            Container(
                              margin: EdgeInsets.symmetric(horizontal: 20),
                              padding: EdgeInsets.symmetric(vertical: 0),
                              child: TextFormField(
                                scrollPadding: EdgeInsets.zero,
                                decoration: InputDecoration(
                                    isDense: true,
                                    contentPadding: EdgeInsets.all(0.0),
                                    prefixIcon: const Icon(
                                      Icons.search,
                                    ),
                                    suffixIcon: const Icon(Icons.directions),
                                    hintText: "Search",
                                    hintStyle: TextStyle(
                                        fontWeight: FontWeight.bold,
                                        fontSize: 15),
                                    border: OutlineInputBorder(
                                      borderRadius: BorderRadius.circular(40),
                                    )),
                              ),
                            ),
                            SizedBox(height: 10),
                            Row(
                              // type: BottomNavigationBarType.fixed,
                              // backgroundColor: Color(0xFF6200EE),
                              // selectedItemColor: Colors.white,
                              // unselectedItemColor:Colors.white.withOpacity(.60),
                              // selectedFontSize: 14,
                              // unselectedFontSize: 14,
                              // onTap: (value) {
                              //   print("the value is $value");
                              //   if (value == 0) {
                              //     controller.animateCamera(
                              //         CameraUpdate.newCameraPosition(
                              //             CameraPosition(
                              //       target: convertToLatLng(),
                              //       // zoom: 17,
                              //       // tilt: 30
                              //     )));
                              //   } else if (value == 1) {
                              //     showModalBottomSheet<void>(
                              //       context: context,
                              //       builder: (BuildContext context) {
                              //         return Container(
                              //           decoration: const BoxDecoration(
                              //               color: Colors.white,
                              //               borderRadius: BorderRadius.only(
                              //                   topLeft:
                              //                       Radius.circular(50),
                              //                   topRight:
                              //                       Radius.circular(50))),
                              //           child: Padding(
                              //             padding:
                              //                 const EdgeInsets.all(10.0),
                              //             child: SingleChildScrollView(
                              //               child: Column(
                              //                 crossAxisAlignment:
                              //                     CrossAxisAlignment.start,
                              //                 children: [
                              //                   TextButton(
                              //                       onPressed: () {
                              //                         setState(() {
                              //                           isLoading = true;
                              //                         });
                              //                         customPOIbasedonLevelId(
                              //                             0);
                              //                         Navigator.pop(
                              //                             context);
                              //                       },
                              //                       child: Text("Level 0")),
                              //                   TextButton(
                              //                       onPressed: () {
                              //                         setState(() {
                              //                           isLoading = true;
                              //                         });
                              //                         customPOIbasedonLevelId(
                              //                             1);
                              //                         Navigator.pop(
                              //                             context);
                              //                       },
                              //                       child: Text("Level 1")),
                              //                   TextButton(
                              //                       onPressed: () {
                              //                         setState(() {
                              //                           isLoading = true;
                              //                         });
                              //                         customPOIbasedonLevelId(
                              //                             2);
                              //                         Navigator.pop(
                              //                             context);
                              //                       },
                              //                       child: Text("Level 2")),
                              //                   TextButton(
                              //                       onPressed: () {
                              //                         setState(() {
                              //                           isLoading = true;
                              //                         });
                              //                         customPOIbasedonLevelId(
                              //                             3);
                              //                         Navigator.pop(
                              //                             context);
                              //                       },
                              //                       child: Text("Level 3")),
                              //                   TextButton(
                              //                       onPressed: () {
                              //                         setState(() {
                              //                           isLoading = true;
                              //                         });
                              //                         customPOIbasedonLevelId(
                              //                             4);
                              //                         Navigator.pop(
                              //                             context);
                              //                       },
                              //                       child: Text("Level 4")),
                              //                 ],
                              //               ),
                              //             ),
                              //           ),
                              //         );
                              //       },
                              //     );
                              //   } else if (value == 3) {
                              //     showModalBottomSheet<void>(
                              //       context: context,
                              //       builder: (BuildContext context) {
                              //         return Container(
                              //           decoration: const BoxDecoration(
                              //               color: Colors.white,
                              //               borderRadius: BorderRadius.only(
                              //                   topLeft:
                              //                       Radius.circular(50),
                              //                   topRight:
                              //                       Radius.circular(50))),
                              //           child: Padding(
                              //             padding:
                              //                 const EdgeInsets.all(10.0),
                              //             child: SingleChildScrollView(
                              //               child: Column(
                              //                 crossAxisAlignment:
                              //                     CrossAxisAlignment.start,
                              //                 children: [
                              //                   TextButton(
                              //                       onPressed: () {
                              //                         // customPOIbasedontTERMINALId(
                              //                         //         1)
                              //                         //     .then((value) {
                              //                         //   controller.animateCamera(
                              //                         //       CameraUpdate.newCameraPosition(CameraPosition(
                              //                         //           target: LatLng(
                              //                         //               72.85610889365556,
                              //                         //               19.09214918115378),
                              //                         //           zoom: 17,
                              //                         //           tilt: 30.0)));
                              //                         // });

                              //                         controller.animateCamera(
                              //                             CameraUpdate.newCameraPosition(CameraPosition(
                              //                                 target: LatLng(
                              //                                     19.09214918115378,
                              //                                     72.85610889365556),
                              //                                 zoom: 17,
                              //                                 tilt: 30.0)));

                              //                         Navigator.pop(
                              //                             context);
                              //                         void addSymbol(
                              //                             MapboxMapController
                              //                                 mapBoxController) {
                              //                           mapBoxController
                              //                               .addSymbol(
                              //                             SymbolOptions(
                              //                               geometry: LatLng(
                              //                                   19.09214918115378,
                              //                                   72.85610889365556),
                              //                               iconImage:
                              //                                   "assets/symbols/Oval.png",
                              //                               iconSize: 3,
                              //                             ),
                              //                           );
                              //                         }
                              //                       },
                              //                       child:
                              //                           Text("Terminal 1")),
                              //                   TextButton(
                              //                       onPressed: () {
                              //                         // setState(() {
                              //                         //   isLoading = true;
                              //                         // });
                              //                         // customPOIbasedontTERMINALId(
                              //                         //     2);
                              //                         controller.animateCamera(
                              //                             CameraUpdate.newCameraPosition(CameraPosition(
                              //                                 target: LatLng(
                              //                                     19.099013794366645,
                              //                                     72.87337468789997),
                              //                                 zoom: 17,
                              //                                 tilt: 30.0)));
                              //                         void addSymbol(
                              //                             MapboxMapController
                              //                                 mapBoxController) {
                              //                           mapBoxController
                              //                               .addSymbol(
                              //                             SymbolOptions(
                              //                               geometry:
                              //                                   LatLng(
                              //                                 19.099013794366645,
                              //                                 72.87337468789997,
                              //                               ),
                              //                               iconImage:
                              //                                   "assets/symbols/Oval.png",
                              //                               iconSize: 3,
                              //                             ),
                              //                           );
                              //                         }

                              //                         Navigator.pop(
                              //                             context);
                              //                       },
                              //                       child:
                              //                           Text("Terminal 2")),
                              //                 ],
                              //               ),
                              //             ),
                              //           ),
                              //         );
                              //       },
                              //     );
                              //   }
                              // },
                              mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                              children: [
                                // BottomNavigationBarItem(
                                //   label: 'Locate Me',
                                //   icon: Icon(Icons.gps_fixed),
                                // ),
                                // BottomNavigationBarItem(
                                //   label: 'Levels',
                                //   icon: Icon(Icons.layers),
                                // ),
                                // BottomNavigationBarItem(
                                //   label: 'Navigate',
                                //   icon: Icon(Icons.directions),
                                // ),
                                // BottomNavigationBarItem(
                                //   label: 'Terminal',
                                //   icon: Icon(Icons.airplane_ticket),
                                // ),
                              ],
                            ),

                            // Row(
                            //   mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                            //   children: [
                            //     GestureDetector(
                            //       onTap: () {
                            //         controller.animateCamera(
                            //             CameraUpdate.newCameraPosition(
                            //                 CameraPosition(
                            //                     target: convertToLatLng())));
                            //       },
                            //       child: Container(
                            //         // decoration: const BoxDecoration(
                            //         //     color: Colors.red,
                            //         //     borderRadius: BorderRadius.all(
                            //         //         Radius.circular(10))),
                            //         // color: Colors.green,
                            //         height: 25,
                            //         width: 25,
                            //         child:
                            //             Image.asset("assets/images/location.png"),
                            //       ),
                            //     ),
                            //     GestureDetector(
                            //         onTap: () {},
                            //         child: Container(
                            //           height: 25,
                            //           width: 25,
                            //           child:
                            //               Image.asset("assets/images/layers.png"),
                            //         )),
                            //     GestureDetector(
                            //         onTap: () {},
                            //         child: Container(
                            //           height: 25,
                            //           width: 25,
                            //           child: Image.asset(
                            //               "assets/images/navigate.png"),
                            //         )),
                            //     GestureDetector(
                            //         onTap: () {},
                            //         child: Container(
                            //           height: 25,
                            //           width: 25,
                            //           child: Image.asset(
                            //               "assets/images/terminal.png"),
                            //         )),
                            //   ],
                            // ),
                            SizedBox(height: 10),
                            SizedBox(
                              height: myHeight - 48,
                              child: SingleChildScrollView(
                                padding: EdgeInsets.symmetric(horizontal: 20),
                                child: Column(
                                  mainAxisAlignment: MainAxisAlignment.start,
                                  crossAxisAlignment: CrossAxisAlignment.start,
                                  children: [
                                    // SizedBox(height: 5),
                                    Text(
                                      "Explore",
                                      style: TextStyle(
                                          fontSize: fontSize,
                                          fontStyle: FontStyle.italic),
                                    ),
                                    SizedBox(height: 15),
                                    Row(
                                        mainAxisAlignment:
                                            MainAxisAlignment.spaceAround,
                                        children: [
                                          Column(
                                            mainAxisAlignment:
                                                MainAxisAlignment.start,
                                            crossAxisAlignment:
                                                CrossAxisAlignment.start,
                                            children: [
                                              Row(
                                                mainAxisAlignment:
                                                    MainAxisAlignment
                                                        .spaceBetween,
                                                children: [
                                                  Image.asset(
                                                    // "assets/symbols/Oval.png",
                                                    "assets/images/restro2.png",
                                                    // "assets/symbols/neww.png",
                                                    height: 30,
                                                    width: 30,
                                                  ),
                                                  SizedBox(width: 10),
                                                  Text(
                                                    "Restaurants",
                                                    style: TextStyle(
                                                        fontSize: fontSize),
                                                  )
                                                ],
                                              ),
                                              SizedBox(
                                                height: 15,
                                              ),
                                              Row(
                                                children: [
                                                  Image.asset(
                                                    "assets/images/shopping.png",
                                                    height: 35,
                                                    width: 35,
                                                  ),
                                                  SizedBox(width: 10),
                                                  Text(
                                                    "Shopping",
                                                    style: TextStyle(
                                                        fontSize: fontSize),
                                                  )
                                                ],
                                              )
                                            ],
                                          ),
                                          Column(
                                            crossAxisAlignment:
                                                CrossAxisAlignment.start,
                                            children: [
                                              Row(
                                                children: [
                                                  Image.asset(
                                                    "assets/images/facilities.png",
                                                    height: 35,
                                                    width: 35,
                                                  ),
                                                  SizedBox(width: 10),
                                                  Text(
                                                    "Facilities",
                                                    style: TextStyle(
                                                        fontSize: fontSize),
                                                  )
                                                ],
                                              ),
                                              SizedBox(
                                                height: 15,
                                              ),
                                              Row(
                                                children: [
                                                  Image.asset(
                                                    "assets/images/utilities.png",
                                                    height: 35,
                                                    width: 35,
                                                  ),
                                                  SizedBox(width: 10),
                                                  Text(
                                                    "Utilities",
                                                    style: TextStyle(
                                                        fontSize: fontSize),
                                                  )
                                                ],
                                              )
                                            ],
                                          )
                                        ]),
                                  ],
                                ),
                              ),
                            ),
                          ],
                        )
                        // Container(
                        //   height: 60,
                        //   // width: 60,
                        //   decoration: const BoxDecoration(
                        //       color: Colors.grey,
                        //       borderRadius:
                        //           BorderRadius.all(Radius.circular(20))),
                        //   child: Padding(
                        //     padding: const EdgeInsets.all(3.0),
                        //     child: Flexible(
                        //       child: Row(
                        //         mainAxisAlignment: MainAxisAlignment.center,
                        //         children: [
                        //           Container(
                        //             // color: Colors.green,
                        //             // height: 25,
                        //             // width: 25,
                        //             child: Image.asset(
                        //                 "assets/images/location.png"),
                        //           ),
                        //           Container(
                        //             // color: Colors.green,
                        //             // height: 25,
                        //             // width: 25,
                        //             child: Image.asset(
                        //                 "assets/images/location.png"),
                        //           ),
                        //         ],
                        //       ),
                        //     ),
                        //   ),
                        // ),
                      ],
                    ),
            ),
          ],
        ),
      )),
      // floatingActionButton: Container(
      //   margin: EdgeInsets.only(bottom: 100),
      //   color: Colors.amberAccent,
      //   child: Row(
      //     mainAxisAlignment: MainAxisAlignment.spaceBetween,
      //     crossAxisAlignment: CrossAxisAlignment.end,
      //     children: [
      //       FloatingActionButton(
      //           backgroundColor: Colors.blue,
      //           child: Icon(Icons.gps_fixed),
      //           onPressed: () {
      //             // _showToast();
      //             controller.animateCamera(
      //                 CameraUpdate.newCameraPosition(_initialCameraPosition));
      //           }),
      //       Column(
      //         mainAxisSize: MainAxisSize.min,
      //         children: [
      //           FloatingActionButton(
      //               backgroundColor: Colors.blue,
      //               child: Icon(Icons.gps_fixed),
      //               onPressed: () {
      //                 // _showToast();
      //                 controller.animateCamera(CameraUpdate.newCameraPosition(
      //                     _initialCameraPosition));
      //               }),
      //           FloatingActionButton(
      //               backgroundColor: Colors.blue,
      //               child: Icon(Icons.gps_fixed),
      //               onPressed: () {
      //                 // _showToast();
      //                 controller.animateCamera(CameraUpdate.newCameraPosition(
      //                     _initialCameraPosition));
      //               }),
      //           FloatingActionButton(
      //               backgroundColor: Colors.blue,
      //               child: Icon(Icons.gps_fixed),
      //               onPressed: () {
      //                 // _showToast();
      //                 controller.animateCamera(CameraUpdate.newCameraPosition(
      //                     _initialCameraPosition));
      //               }),
      //         ],
      //       ),
      //     ],
      //   ),
      // ),
    );
  }

  Widget _body(String URL) {
    return MapboxMap(
      accessToken: dotenv.env['MAPBOX_ACCESS_TOKEN'],
      initialCameraPosition:
          CameraPosition(target: LatLng(19.098588, 72.874341), zoom: 17),
      styleString: URL,
      compassEnabled: false,
      myLocationEnabled: true,
      onMapCreated: (MapboxMapController mapBoxController) {
        controller = mapBoxController;
        // isMapRead = true;

        print(">>>>>>>>>>>>>>>>>>>> 1074 >>>>>>>>    mapcreated");

        // setState(() {
        //   mapController.animateCamera(
        //     CameraUpdate.newCameraPosition(
        //       const CameraPosition(
        //         bearing: 310.0,
        //         target: LatLng(19.098977052761047, 72.87443855619064),
        //         tilt: 60.0,
        //         zoom: 17.0,
        //       ),
        //     ),
        //   );
        //
        //   // addGeojsonCluster(mapController);
        // });

        controller.onSymbolTapped.add((argument) {
          tappedaFunction(argument);
        });
      },
    );
  }
}
